#include <QtGui>
#include <stdio.h>
#include "imgconvert.h"
#include "mainwin.h"

MainWin::MainWin(QWidget *parent)
{
    setupUi(this);

    source = cvCaptureFromCAM(0);

    startTimer(30);
}

MainWin::~MainWin(void)
{
    cvReleaseCapture(&source);
}

void MainWin::timerEvent(QTimerEvent*)
{
    IplImage *image; // Eingelesenes Bild im OpenCV-Format
    QGraphicsScene *scene = new QGraphicsScene(); // Grafikszene

    scene->setBackgroundBrush(QColor(0, 0, 0)); // Schwarzer Hintergrund
    image = cvQueryFrame(source); // Frame auslesen
    scene->addPixmap(QPixmap::fromImage(MirrorImage(ConvertImage(image), H_MIRROR)));  // Bild in QImage konvertieren, auf den Kopf stellen und anzeigen
    ViewBox->setScene(scene); // Szene anzeigen
}
